> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.icepanel.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.icepanel.io/_mcp/server.

# List

GET https://api.icepanel.io/v1/landscapes/{landscapeId}/versions/{versionId}/model/objects

Reference: https://developer.icepanel.io/api-reference/model/objects/list

## Authentication

- `X-API-Key` header (required) — API key authentication
- `Authorization` header (bearer token, required) — Bearer token authentication

## Request

### Path parameters

- `landscapeId` (string, required)
- `versionId` (string, required)

### Query parameters

- `filter` (ModelObjectFilter, optional)
- `expand` (list of enum, optional)
  - Allowed values: `domain`, `flows`, `tags`, `technologies`
- `cursor` (string, optional)
- `limit` (integer, optional)

## Response

### 200

OK

- `modelObjects` (list of ModelObjectExpanded, required)
- `nextCursor` (string, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 401 Unauthorized Error

Unauthorized

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 403 Forbidden Error

Forbidden

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 404 Not Found Error

Not Found

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 422 Unprocessable Entity Error

Unprocessable Entity

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 429 Too Many Requests Error

Resource Exhausted

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

### 500 Internal Server Error

Internal Server

- `message` (string, required)
- `code` (string, optional)
- `errors` (list of string, optional)

## Types

### ModelObjectFilter

- `domainId` (ModelObjectFilterDomainId, optional)
- `external` (boolean, optional)
- `groupIds` (ModelObjectFilterGroupIds, optional)
- `handleId` (ModelObjectFilterHandleId, optional)
- `labels` (map from string to string, optional)
- `linked` (boolean, optional)
- `name` (string, optional)
- `parentId` (string, optional, nullable) — Filter objects with this parent id
- `parentIds` (string, optional) — Filter objects or child objects with this parent id
- `status` (ModelObjectFilterStatus, optional)
- `tagIds` (ModelObjectFilterTagIds, optional)
- `teamIds` (ModelObjectFilterTeamIds, optional)
- `technologyIds` (ModelObjectFilterTechnologyIds, optional)
- `type` (ModelObjectFilterType, optional)

### ModelObjectExpanded

- `childDiagramIds` (list of string, required) — Child diagram IDs
- `childIds` (list of string, required) — Child model object IDs, only one level down
- `commit` (double, required)
- `createdAt` (datetime, required)
- `createdBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `createdById` (string, required)
- `diagrams` (map from string to ModelObjectDiagram, required)
- `domainId` (string, required)
- `external` (boolean, required)
- `flows` (map from string to ModelObjectFlow, required)
- `groupIds` (list of string, required) — IDs of the groups this model object belongs to
- `handleId` (string, required)
- `icon` (ModelObjectIcon, required, nullable)
- `id` (string, required)
- `labels` (map from string to string, required) — Generic key value store used for creating custom integrations
- `landscapeId` (string, required)
- `linked` (boolean, required)
- `links` (map from string to RealityLink, required)
- `name` (string, required)
- `parentId` (string, required, nullable) — Parent model object ID, null for the root level model object
- `parentIds` (list of string, required) — Parent model object IDs for the whole hierarchy, ending with the root model object
- `status` (enum, required)
  - Allowed values: `deprecated`, `future`, `live`, `removed`
- `tagIds` (list of string, required) — Tag IDs assigned to this model
- `teamIds` (list of string, required) — Team IDs that own this model object, does not propergate up or down
- `teamOnlyEditing` (boolean, required) — Model object (+child diagram, diagram groups and flows) can only be edited by owners and admins
- `technologyIds` (list of string, required) — Technology IDs assigned to this model
- `type` (enum, required)
  - Allowed values: `actor`, `app`, `component`, `group`, `root`, `store`, `system`
- `updatedAt` (datetime, required)
- `updatedBy` (enum, required)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `updatedById` (string, required)
- `version` (double, required)
- `versionId` (string, required)
- `caption` (string, optional) — Short summary of the object shown as the display description
- `deletedAt` (datetime, optional)
- `deletedBy` (enum, optional)
  - Allowed values: `user`, `api-key`, `notification-key`, `service`
- `deletedById` (string, optional)
- `description` (string, optional)
- `domain` (DomainExport, optional)
- `flowsExpanded` (map from string to FlowExport, optional) — Expanded flow exports keyed by flow ID.
- `latestEntityId` (string, optional)
- `tags` (map from string to TagExport, optional)
- `technologies` (map from string to TechnologyExport, optional)

### ModelObjectFilterDomainId

### ModelObjectFilterGroupIds

### ModelObjectFilterHandleId

### ModelObjectFilterStatus

### ModelObjectFilterTagIds

### ModelObjectFilterTeamIds

### ModelObjectFilterTechnologyIds

### ModelObjectFilterType

### ModelObjectDiagram

- `id` (string, required)
- `objectId` (string, required)

### ModelObjectFlow

- `id` (string, required)
- `stepId` (string, required)

### ModelObjectIcon

- `catalogTechnologyId` (string, required)
- `name` (string, required)
- `urlDark` (string, optional) — Icon that only works on dark backgrounds
- `urlLight` (string, optional) — Icon that only works on light backgrounds
- `url` (string, optional, deprecated) — Use either urlDark or urlLight

### RealityLink

- `index` (double, required)
- `id` (string, required) — Random 20 character identifier
- `connectionResolveUrl` (string, optional) — Resolve the connector from a publicly accessible URL
- `connector` (RealityConnector, optional) — Links this to a resource in reality, if set periodic checks are performed and the status is updated
- `customName` (string, optional, nullable) — Friendly name for the link set by the user
- `url` (string, optional) — URL pointing to the resource in reality, resolved from the last sync
- `errorMessage` (string, optional) — Error message that was received during the last sync
- `name` (string, optional) — Friendly name describing the resource in reality, resolved from the last sync
- `status` (enum, optional) — Response that was received from the last sync with reality
  - Allowed values: `valid`, `invalid`

### DomainExport

- `id` (string, required)
- `name` (string, required)

### FlowExport

- `id` (string, required)
- `name` (string, required)
- `showConnectionNames` (boolean, required)
- `steps` (map from string to FlowStepExport, required)

### TagExport

- `color` (enum, required)
  - Allowed values: `blue`, `green`, `yellow`, `orange`, `red`, `beaver`, `dark-blue`, `purple`, `pink`, `white`, `grey`, `black`
- `groupId` (string, required)
- `id` (string, required)
- `name` (string, required)

### TechnologyExport

- `color` (enum, required)
  - Allowed values: `blue`, `green`, `yellow`, `orange`, `red`, `beaver`, `dark-blue`, `purple`, `pink`, `white`, `grey`, `black`
- `id` (string, required)
- `name` (string, required)
- `provider` (enum, required)
  - Allowed values: `aws`, `azure`, `gcp`, `microsoft`, `salesforce`, `atlassian`, `apache`, `supabase`
- `type` (enum, required)
  - Allowed values: `data-storage`, `deployment`, `framework-library`, `gateway`, `other`, `language`, `message-broker`, `network`, `protocol`, `runtime`, `service-tool`
- `description` (string, optional)
- `docsUrl` (string, optional)
- `iconUrlDark` (string, optional)
- `iconUrlLight` (string, optional)
- `nameShort` (string, optional)
- `updatesUrl` (string, optional)
- `websiteUrl` (string, optional)
- `iconUrl` (string, optional, deprecated) — Use either iconUrlDark or iconUrlLight

### RealityConnector

### FlowStepExport

- `description` (string, required) — Descriptive name for the flow step
- `id` (string, required)
- `index` (double, required)
- `originId` (string, required)
- `targetId` (string, required)
- `type` (enum, required) — Type of flow step - deprecated values: reply
  - Allowed values: `alternate-path`, `subflow`, `outgoing`, `parallel-path`, `reply`, `self-action`, `introduction`, `information`, `conclusion`
- `viaId` (string, required)
- `detailedDescription` (string, optional) — Long description for the flow step

### RealityConnectorUrl

- `type` (enum, required)
  - Allowed values: `url`
- `url` (string, required)

### RealityConnectorAzureDevopsRepo

- `accountName` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `azure-devops-repo`

### RealityConnectorAzureDevopsBranch

- `accountName` (string, required)
- `branchName` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `azure-devops-branch`

### RealityConnectorAzureDevopsFolder

- `accountName` (string, required)
- `branchName` (string, required)
- `path` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `azure-devops-folder`

### RealityConnectorAzureDevopsFile

- `accountName` (string, required)
- `branchName` (string, required)
- `path` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `azure-devops-file`

### RealityConnectorBitbucketRepo

- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-repo`
- `workspaceId` (string, required)

### RealityConnectorBitbucketBranch

- `branchName` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-branch`
- `workspaceId` (string, required)

### RealityConnectorBitbucketFolder

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-folder`
- `workspaceId` (string, required)

### RealityConnectorBitbucketFile

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (string, required)
- `repositoryId` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-file`
- `workspaceId` (string, required)

### RealityConnectorBitbucketServerRepo

- `projectId` (double, required)
- `repositoryId` (double, required)
- `serverUrl` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-server-repo`

### RealityConnectorBitbucketServerBranch

- `branchName` (string, required)
- `projectId` (double, required)
- `repositoryId` (double, required)
- `serverUrl` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-server-branch`

### RealityConnectorBitbucketServerFolder

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (double, required)
- `repositoryId` (double, required)
- `serverUrl` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-server-folder`

### RealityConnectorBitbucketServerFile

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (double, required)
- `repositoryId` (double, required)
- `serverUrl` (string, required)
- `type` (enum, required)
  - Allowed values: `bitbucket-server-file`

### RealityConnectorGithubRepo

- `ownerId` (double, required)
- `repositoryId` (double, required)
- `type` (enum, required)
  - Allowed values: `github-repo`

### RealityConnectorGithubBranch

- `branchName` (string, required)
- `ownerId` (double, required)
- `repositoryId` (double, required)
- `type` (enum, required)
  - Allowed values: `github-branch`

### RealityConnectorGithubFolder

- `branchName` (string, required)
- `ownerId` (double, required)
- `path` (string, required)
- `repositoryId` (double, required)
- `type` (enum, required)
  - Allowed values: `github-folder`

### RealityConnectorGithubFile

- `branchName` (string, required)
- `ownerId` (double, required)
- `path` (string, required)
- `repositoryId` (double, required)
- `type` (enum, required)
  - Allowed values: `github-file`

### RealityConnectorGitlabRepo

- `projectId` (double, required)
- `type` (enum, required)
  - Allowed values: `gitlab-repo`

### RealityConnectorGitlabBranch

- `branchName` (string, required)
- `projectId` (double, required)
- `type` (enum, required)
  - Allowed values: `gitlab-branch`

### RealityConnectorGitlabFolder

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (double, required)
- `type` (enum, required)
  - Allowed values: `gitlab-folder`

### RealityConnectorGitlabFile

- `branchName` (string, required)
- `path` (string, required)
- `projectId` (double, required)
- `type` (enum, required)
  - Allowed values: `gitlab-file`

## Examples

**Response**

```json
{
  "modelObjects": [
    {
      "childDiagramIds": [
        "string"
      ],
      "childIds": [
        "string"
      ],
      "commit": 1.1,
      "createdAt": "2024-01-15T09:30:00Z",
      "createdBy": "user",
      "createdById": "string",
      "diagrams": {},
      "domainId": "string",
      "external": true,
      "flows": {},
      "groupIds": [
        "string"
      ],
      "handleId": "string",
      "icon": {
        "catalogTechnologyId": "string",
        "name": "string",
        "urlDark": [
          "/organizations/{organizationId}/dark/{catalogTechnologyId}.png",
          "/dark/{catalogTechnologyId}.png"
        ],
        "urlLight": [
          "/organizations/{organizationId}/light/{catalogTechnologyId}.png",
          "/light/{catalogTechnologyId}.png"
        ],
        "url": "string"
      },
      "id": "string",
      "labels": {},
      "landscapeId": "string",
      "linked": true,
      "links": {},
      "name": "string",
      "parentId": "string",
      "parentIds": [
        "string"
      ],
      "status": "deprecated",
      "tagIds": [
        "string"
      ],
      "teamIds": [
        "string"
      ],
      "teamOnlyEditing": true,
      "technologyIds": [
        "string"
      ],
      "type": "actor",
      "updatedAt": "2024-01-15T09:30:00Z",
      "updatedBy": "user",
      "updatedById": "string",
      "version": 1.1,
      "versionId": "string",
      "caption": "string",
      "deletedAt": "2024-01-15T09:30:00Z",
      "deletedBy": "user",
      "deletedById": "string",
      "description": "string",
      "domain": {
        "id": "string",
        "name": "string"
      },
      "flowsExpanded": {},
      "latestEntityId": "string",
      "tags": {},
      "technologies": {}
    }
  ],
  "nextCursor": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.icepanel.io/v1/landscapes/landscapeId/versions/versionId/model/objects"

headers = {"X-API-Key": "<apiKey>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.icepanel.io/v1/landscapes/landscapeId/versions/versionId/model/objects"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("X-API-Key", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```csharp
using RestSharp;

var client = new RestClient("https://api.icepanel.io/v1/landscapes/landscapeId/versions/versionId/model/objects");
var request = new RestRequest(Method.GET);
request.AddHeader("X-API-Key", "<apiKey>");
IRestResponse response = client.Execute(request);
```